package com.ruoyi.gysl.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.gysl.entity.BuildingInformation;
import com.ruoyi.gysl.entity.Xmpjqd;
import com.ruoyi.gysl.entity.request.XmpjqdPageReq;
import com.ruoyi.gysl.entity.response.XmhxDetail.XmhxDetail;
import com.ruoyi.gysl.entity.response.XmhxResponse;
import com.ruoyi.gysl.entity.response.XmpjqdOneResponse;
import com.ruoyi.gysl.mapper.XmpjqdMapper;
import com.ruoyi.gysl.service.BuildingInformationService;
import com.ruoyi.gysl.service.PjpzService;
import com.ruoyi.gysl.service.XmpjqdService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * 项目评价清单(Xmpjqd)表服务实现类
 *
 * @author makejava
 * @since 2025-03-22 09:22:33
 */
@Service("xmpjqdService")
public class XmpjqdServiceImpl extends ServiceImpl<XmpjqdMapper, Xmpjqd> implements XmpjqdService {

    @Resource
    private XmpjqdMapper xmpjqdMapper;

    @Resource
    private BuildingInformationService buildingInformationService;

    @Resource
    private PjpzService pjpzService;

    /**
     * 分页查询所有目录
     *
     * @param page 分页对象
     * @return 所有数据
     */
    @Override
    public Page<Xmpjqd> page(Page<Xmpjqd> page, XmpjqdPageReq req) {
        Page<Xmpjqd> page1 = xmpjqdMapper.page(page, req);
        for (int i = 0; i < page1.getRecords().size(); i++) {
            page1.getRecords().get(i).setPjdj(i + 1);
        }
        return page1;
    }

    /**
     * 通过主键查询单条项目评价清单
     *
     * @param id 主键
     * @return 单条数据
     */
    @Override
    public List<XmpjqdOneResponse> selectOnePj(Long id) {
        List<XmpjqdOneResponse> xmpjqdOneResponses = xmpjqdMapper.selectOnePj(id);
        //获取项目评价配置
        pjpzService.list().forEach(x->{
            XmpjqdOneResponse xr = new XmpjqdOneResponse();
            xr.setYsmc(x.getPjys());
            xmpjqdOneResponses.add(xr);
        });
        //查询所有的建筑信息,只保留是重要楼栋的随机一条
//        List<BuildingInformation> list = xmpjqdMapper.getImportantBuildings();

//        //层数
//        list.sort(Comparator.comparing(BuildingInformation::getFloor).reversed());
//        XmpjqdOneResponse a1 = new XmpjqdOneResponse();
//        a1.setYsmc("层数");
//        for (int i = 0; i < list.size(); i++) {
//            if (Objects.equals(list.get(i).getXmId(), id)) {
//                a1.setPjpm(i + 1);
//            }
//        }
//        a1.setCount(String.valueOf(list.size()));
//        xmpjqdOneResponses.add(a1);
//        //首层层高
//        XmpjqdOneResponse a2 = new XmpjqdOneResponse();
//        list.sort(Comparator.comparing(BuildingInformation::getScgd).reversed());
//        a2.setYsmc("首层层高");
//        for (int i = 0; i < list.size(); i++) {
//            if (Objects.equals(list.get(i).getXmId(), id)) {
//                a2.setPjpm(i + 1);
//            }
//        }
//        a2.setCount(String.valueOf(list.size()));
//        xmpjqdOneResponses.add(a2);
//
//        //二层及以上层高
//        XmpjqdOneResponse a3 = new XmpjqdOneResponse();
//        list.sort(Comparator.comparing(BuildingInformation::getTwoAndFourCg).reversed());
//        a3.setYsmc("二层及以上层高");
//        for (int i = 0; i < list.size(); i++) {
//            if (Objects.equals(list.get(i).getXmId(), id)) {
//                a3.setPjpm(i + 1);
//            }
//        }
//        a3.setCount(String.valueOf(list.size()));
//        xmpjqdOneResponses.add(a3);
//
//        //首层地面载荷
//        XmpjqdOneResponse a4 = new XmpjqdOneResponse();
//        list.sort(Comparator.comparing(BuildingInformation::getScdmhz).reversed());
//        a4.setYsmc("首层地面载荷");
//        for (int i = 0; i < list.size(); i++) {
//            if (Objects.equals(list.get(i).getXmId(), id)) {
//                a4.setPjpm(i + 1);
//            }
//        }
//        a4.setCount(String.valueOf(list.size()));
//        xmpjqdOneResponses.add(a4);
//
//        //二层及以上楼面荷载
//        XmpjqdOneResponse a5 = new XmpjqdOneResponse();
//        list.sort(Comparator.comparing(BuildingInformation::getTwoAndThreeLmhz).reversed());
//        a5.setYsmc("二层及以上楼面荷载");
//        for (int i = 0; i < list.size(); i++) {
//            if (Objects.equals(list.get(i).getXmId(), id)) {
//                a5.setPjpm(i + 1);
//            }
//        }
//        a5.setCount(String.valueOf(list.size()));
//        xmpjqdOneResponses.add(a5);
        return xmpjqdOneResponses;
    }

    /**
     * 通过主键查询单条项目画像
     *
     * @param id 主键
     * @return 单条数据
     */
    @Override
    public List<XmhxResponse> oneXmhx(Serializable id) {
        List<XmhxResponse> obj = new ArrayList<>();
        XmhxResponse xr = new XmhxResponse();
        xr.setType(1);
        xr.setList(xmpjqdMapper.maxXmhx());

        XmhxResponse xr1 = new XmhxResponse();
        List<XmhxDetail> xmhxDetails = xmpjqdMapper.oneXmhx(id);
        BuildingInformation one = buildingInformationService.lambdaQuery()
                .eq(BuildingInformation::getXmId, id)
                .eq(BuildingInformation::getSfwzyld, 1)
                .groupBy(BuildingInformation::getXmId).one();
        if (one != null) {
            XmhxDetail a1 = new XmhxDetail();
            a1.setYsmc("层数");
            a1.setPjpm(one.getFloor() == null ? "" : String.valueOf(one.getFloor()));
            XmhxDetail a2 = new XmhxDetail();
            a2.setYsmc("首层层高");
            a2.setPjpm(String.valueOf(one.getScgd() == null ? "" : one.getScgd()));
            XmhxDetail a3 = new XmhxDetail();
            a3.setYsmc("二层及以上层高");
            a3.setPjpm(String.valueOf(one.getTwoAndFourCg() == null ? "" : one.getTwoAndFourCg()));
            XmhxDetail a4 = new XmhxDetail();
            a4.setYsmc("二层及以上楼面荷载");
            a4.setPjpm(String.valueOf(one.getTwoAndThreeLmhz() == null ? "" : one.getTwoAndThreeLmhz()));
            xr1.setType(2);
            xmhxDetails.add(a1);
            xmhxDetails.add(a2);
            xmhxDetails.add(a3);
            xmhxDetails.add(a4);
            xr1.setList(xmhxDetails);
        } else {
            xr1.setType(2);
            xr1.setList(new ArrayList<>());
        }

        XmhxResponse xr2 = new XmhxResponse();
        xr2.setType(3);
        List<XmhxDetail> zws = new ArrayList<>();
        //总投资额
        List<BigDecimal> bigDecimals = xmpjqdMapper.zwsXmhx();
        XmhxDetail z1 = getXmhxDetails(bigDecimals, "总投资额");
        zws.add(z1);
        //获取建筑信息表
        List<BuildingInformation> ib = xmpjqdMapper.getImportantBuildings();
        //层数拿出来
        List<Integer> floor = ib.stream()
                .map(BuildingInformation::getFloor)
                .filter(Objects::nonNull)
                .sorted()
                .collect(Collectors.toList());
        XmhxDetail xmhxDetail = new XmhxDetail();
        xmhxDetail.setYsmc("层数");
        if (floor.size() % 2 == 1) {
            xmhxDetail.setPjpm(String.valueOf(floor.get(floor.size() / 2)));
        } else {
            if(!floor.isEmpty()){
                Integer lower = floor.get(floor.size() / 2 - 1);
                Integer upper = floor.get(floor.size() / 2);
                xmhxDetail.setPjpm(String.valueOf((lower + upper) / 2));
            }else {
                xmhxDetail.setPjpm("0");
            }
        }
        zws.add(xmhxDetail);
        //首层层高
        List<BigDecimal> sccg = ib.stream()
                .map(BuildingInformation::getScgd)
                .filter(Objects::nonNull)
                .sorted()
                .collect(Collectors.toList());
        zws.add(getXmhxDetails(sccg, "首层层高"));
        //二层及以上层高
        List<BigDecimal> ec = ib.stream()
                .map(BuildingInformation::getTwoAndFourCg)
                .filter(Objects::nonNull)
                .sorted()
                .collect(Collectors.toList());
        zws.add(getXmhxDetails(ec, "二层及以上层高"));
        //二层及以上楼载荷
        List<BigDecimal> zh = ib.stream()
                .map(BuildingInformation::getTwoAndThreeLmhz)
                .filter(Objects::nonNull)
                .sorted()
                .collect(Collectors.toList());
        zws.add(getXmhxDetails(zh, "二层及以上楼载荷"));

        xr2.setList(zws);
        obj.add(xr);
        obj.add(xr1);
        obj.add(xr2);
        return obj;
    }

    private static XmhxDetail getXmhxDetails(List<BigDecimal> bigDecimals, String content) {
        XmhxDetail xmhxDetail = new XmhxDetail();
        xmhxDetail.setYsmc(content);
        int length = bigDecimals.size();
        int middleIndex = length / 2;
        // 根据奇偶性计算中位数
        if (length % 2 == 1) {
            xmhxDetail.setPjpm(String.valueOf(bigDecimals.get(middleIndex)));
        } else {
            if(!bigDecimals.isEmpty()){
                BigDecimal lower = bigDecimals.get(middleIndex - 1);
                BigDecimal upper = bigDecimals.get(middleIndex);
                xmhxDetail.setPjpm(
                        String.valueOf(
                                lower.add(upper)
                                        .divide(BigDecimal.valueOf(2), 2, RoundingMode.HALF_UP)  // 2 表示保留两位小数
                        )
                );
            }else {
                xmhxDetail.setPjpm("0");
            }
        }
        return xmhxDetail;
    }
}

